/* 
 * resolve.c, derived from Linux' route.c 
 * Harald Milz (hm@seneca.ix.de) 1995
 * This file is copyrighted according to the 
 * GNU Public License 2.0 or later. 
 */

#include <sys/types.h>
#include <sys/ioctl.h>
#include <sys/socket.h>
#include <net/if.h>
#include <netinet/in.h>
#include <netdb.h>
#include <arpa/nameser.h>
#include <resolv.h>
#include <stdio.h>
#include <errno.h>
#include <fcntl.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <ctype.h>

int resolve(char *name, struct sockaddr_in *sin)
{
	struct hostent *hp;
	struct netent  *np;

	sin->sin_family = AF_INET;
	sin->sin_port = 0;

	/* Try the NETWORKS database to see if this is a known network. */
	if ((np = getnetbyname(name)) != (struct netent *) NULL) {
		sin->sin_addr.s_addr = htonl(np->n_net);
		strcpy(name, np->n_name);
		return (1);
	}
#ifdef DEBUG
	_res.options |= RES_DEBUG;
	res_init();
#endif

	if ((hp = gethostbyname(name)) == (struct hostent *) NULL) {
		errno = h_errno;
		return (-1);
	}
	memcpy((char *) &sin->sin_addr, (char *) hp->h_addr_list[0], hp->h_length);
	strcpy(name, hp->h_name);
/*
 * assume it's a network if the least significate byte is 0,
 * as that's not a valid host address.
 */
	return ((ntohl(sin->sin_addr.s_addr) & 0xff) == 0);
}


char * show (unsigned long ad) {
	static char name[16];
                
        sprintf(name, "%d.%d.%d.%d",
		(int) (ad & 0xFF), (int) ((ad >> 8) & 0xFF),
		(int) ((ad >> 16) & 0xFF),
		(int) ((ad >> 24) & 0xFF));
	name[15] = '\0';
	return name;
}	
		
		
                                                                                        